/*
 * Copyright (c) 2016-2020 Marco Cawthorne <marco@icculus.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF MIND, USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#define TCP_BUFFER_LENGTH 32

typedef struct
{
	filestream m_fSocket;
	string m_strBuffer[TCP_BUFFER_LENGTH];
	int m_iBufferLines;
	int m_iState;
} tcpinfo_t;

enum
{
	STATE_DISCONNECTED,
	STATE_CONNECTING,
	STATE_CONNECTED
};

int TCP_Connect(tcpinfo_t *in, string path);

void TCP_Disconnect(tcpinfo_t *in);

int TCP_Send(tcpinfo_t *in, string msg);

string TCP_Receive(tcpinfo_t *in);

/* you want to run this every frame */
void TCP_Frame(tcpinfo_t *in);

int TCP_GetState(tcpinfo_t *in);
